<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="50%" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="80px" label-position="left">
        <el-row :gutter="10">
          <el-col :span="12">
            <el-form-item label="学校名称" prop="schoolId">
              <el-select v-model="formData.schoolId" placeholder="请选择学校名称">
                <el-option v-for="school in schoolList" :key="school.schoolName" :label="school.schoolName" :value="school.schoolId"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12"
            ><el-form-item label="校区名称" prop="campusName"> <el-input v-model="formData.campusName" placeholder="请输入校区名称" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="校区代码" prop="campusCode"> <el-input v-model="formData.campusCode" placeholder="请输入校区代码" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="校区地址" prop="address"> <el-input v-model="formData.address" placeholder="请输入校区地址" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="邮政编码" prop="postCode"> <el-input v-model="formData.postCode" placeholder="请输入邮政编码" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="联系电话" prop="telephone"> <el-input v-model="formData.telephone" placeholder="请输入联系电话" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="传真" prop="fax"> <el-input v-model="formData.fax" placeholder="请输入传真" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="邮箱" prop="email"> <el-input v-model="formData.email" placeholder="请输入邮箱" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="历史沿革" prop="principal"> <el-input v-model="formData.principal" placeholder="请输入历史沿革" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="备注" prop="remark"> <el-input v-model="formData.remark" placeholder="请输入备注" /> </el-form-item
          ></el-col>
          <el-col :span="12"
            ><el-form-item label="负责人" prop="chargePerson"> <el-input v-model="formData.chargePerson" placeholder="请输入负责人" /> </el-form-item
          ></el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PtCampusForm" lang="ts">
import * as PtCampusApi from '@/api/basics/customer/ptCampus';
import { PtCampusForm } from '@/api/basics/customer/ptCampus/types';
import { PtSchoolVO } from '@/api/basics/customer/ptSchool/types';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'PtCampusForm' });

// 接收父组件传入属性
// const props = defineProps({})

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

/** 数据字典 */
const { sys_yes_no } = toRefs<any>(proxy?.useDict('sys_yes_no'));
// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
const schoolList = ref<PtSchoolVO[]>([]);
// 表单数据
const formData = ref<PtCampusForm>({
  campusId: undefined,
  schoolId: undefined,
  campusName: '',
  campusCode: '',
  address: '',
  postCode: '',
  telephone: '',
  fax: '',
  email: '',
  principal: '',
  remark: '',
  chargePerson: ''
});
// 表单校验规则
// 表单校验规则
const formRules = reactive({
  campusId: [{ required: true, message: 'ID不能为空', trigger: 'blur' }],
  schoolId: [{ required: true, message: '学校名称不能为空', trigger: 'change' }],
  campusName: [{ required: true, message: '校区名称不能为空', trigger: 'blur' }]
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await PtCampusApi.getPtCampus(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    campusId: undefined,
    schoolId: undefined,
    campusName: '',
    campusCode: '',
    address: '',
    postCode: '',
    telephone: '',
    fax: '',
    email: '',
    principal: '',
    remark: '',
    chargePerson: ''
  };
  formRef.value?.resetFields();
};
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as PtCampusForm;
    if (formType.value === 'create') {
      await PtCampusApi.addPtCampus(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await PtCampusApi.updatePtCampus(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};
/** 查询学校信息列表 */
const getSchoolList = async () => {
  const res = await PtCampusApi.listPtSchool();
  schoolList.value = res.rows;
};
/** 初始化 */
onMounted(() => {
  getSchoolList();
});
</script>
